#!/bin/sh

logger "$0: ***** Channel patch & CRDA watch script start"

############################################################## Channel 13 Patch

logger "$0: ***** Patcing hostapd-phy0.conf : channel=13"
sed -i "/channel=/c\channel=13" /tmp/run/hostapd-phy0.conf

logger "$0: ***** Restarting AP" 
kill -9 `cat /tmp/run/wifi-phy0.pid`
sleep 1
/usr/sbin/hostapd -P /var/run/wifi-phy0.pid -B /var/run/hostapd-phy0.conf
sleep 1

############################################################## Region watch

avail_check=1
logger "$0: ***** Entering CRDA watch loop"
while :
do
	msg=`iw reg get`
	echo "$msg" | grep "BO"
	if [ $? -ne 0 ]
	then
		logger "$0: ***** Current region: `head -1 $msg`"
		logger "$0: ***** Current region is not BO, applying region & txpower setting"

		while [ avail_check ]
		do
			logger "$0: ***** Waiting for drone to respond"
			ping -c 1 -w 5 192.168.1.2 &> /dev/null
			if [ $? -ne 0 ]
			then
				logger "$0: ***** Drone is currently unavailable, backoff 20 seconds"
				sleep 20
			else
				logger "$0: ***** Availability confirmed"
				avail_check=0
				break
			fi
		done

		{ sleep 1;echo "iw reg set BO";echo "iw dev wlan0 set txpower limit 2700";sleep 1;} | telnet 192.168.1.2
		logger "$0: ***** Setting drone completed"

		iw reg set BO
		iw dev wlan0 set txpower limit 2700
		logger "$0: ***** Setting RC completed"
	fi

	sleep 20
done